#include "systemc.h"
SC_MODULE(and2) 
{
	sc_in<sc_logic> in1, in2;
	sc_out<sc_logic> out1;
	void do_and2()
	{
		out1.write( in1.read() & in2.read() );
	}
	SC_CTOR(and2) 
	{
		SC_METHOD(do_and2); // registrcia do_nand2 v jadre
		sensitive(in1);
		sensitive(in2); // zoznam citlivosti
	}
};
SC_MODULE(or2) 
{
	sc_in<sc_logic> in1;
	sc_out<sc_logic> out1, out2;
	void do_and2()
	{
		out1.write( in1.read() & in2.read() );
	}
	SC_CTOR(and2) 
	{
		SC_METHOD(do_and2); // registrcia do_nand2 v jadre
		sensitive(in1);
		sensitive(in2); // zoznam citlivosti
	}
};
SC_MODULE(stimulus) 
{
	sc_in<bool> clk;
	sc_out<sc_logic> out1, out2;
};
SC_MODULE(monitor ) 
{
	sc_in<sc_logic> in1;
	sc_in<bool> clk;
};
int sc_main(int argc, char* argv[]) {
	sc_signal <sc_logic> kanal_0, kanal_1, kanal_2, kanal_3, kanal_4, kanal_5, kanal_6, kanal_7, kanal_8;
	sc_clock clk("Hodiny", 10, SC_NS,0.5);

	and2 and_A("Log_clen_AND");
	and_A.in1(kanal_1);
	and_A.in2(kanal_2);
	and_A.out1(kanal_0);

	and2 and_B("Log_clen_AND");
	and_B.in1(kanal_3);
	and_B.in2(kanal_4);
	and_B.out1(kanal_5);

	and2 and_C("Log_clen_AND");
	and_C.in1(kanal_6);
	and_C.in2(kanal_7);
	and_C.out1(kanal_8);

	or2 or_A("Log_clen_AND");
	or_A.in1(kanal_5);
	or_A.out2(kanal_3);
	or_A.out1(kanal_4);

	or2 or_B("Log_clen_AND");
	or_B.in1(kanal_8);
	or_B.out2(kanal_6);
	or_B.out1(kanal_7);
	
	stimulus stim_A("Generator_signalov");
	stim_A.out1(kanal_1);
	stim_A.out2(kanal_2);
	stim_A.clk(clk);
	
	monitor mon_A("Monitor");
	mon_A.in1(kanal_0);
	mon_A.clk(clk);

	sc_start();
	return 0;
}