#include "systemc.h"
SC_MODULE(and2) 
{
	sc_in<sc_logic> in1, in2;
	sc_out<sc_logic> out1;
	void do_and2()
	{
		out1.write( in1.read() & in2.read() );
	}
	SC_CTOR(and2) 
	{
		SC_METHOD(do_and2); // registrcia do_nand2 v jadre
		sensitive(in1);
		sensitive(in2); // zoznam citlivosti
	}
};
SC_MODULE(stimulus) 
{
	sc_in<bool> clk;
	sc_out<sc_logic> out1, out2;
};
SC_MODULE(monitor ) 
{
	sc_in<sc_logic> in1;
	sc_in<bool> clk;
};
int sc_main(int argc, char* argv[]) {
	sc_signal <sc_logic> kanal_0, kanal_1, kanal_2;
	sc_clock clk("Hodiny", 10, SC_NS,0.5);

	and2 and_A("Log_clen_AND");
	and_A.in1(kanal_1);
	and_A.in2(kanal_2);
	and_A.out1(kanal_0);
	
	stimulus stim_A("Generator_signalov");
	stim_A.out1(kanal_1);
	stim_A.out2(kanal_2);
	stim_A.clk(clk);
	
	monitor mon_A("Monitor");
	mon_A.in1(kanal_0);
	mon_A.clk(clk);
	sc_start();
	return 0;
}