-- trojvstupovy log clen OR
entity Obvod_3OR is
    port (A:in Bit_vector(2 downto 0); C:out Bit);
end Obvod_3OR;

-- telo architektry OR
architecture Spravanie of Obvod_3OR is
begin
    C <= (A(2) or A(1)) or A(0);
end Spravanie;
---------------------------------------------
-- stvorvstupovy log clen OR
entity Obvod_4OR is
    port (A:in Bit_vector(3 downto 0); C:out Bit);
end Obvod_4OR;

-- telo architektry OR
architecture Spravanie of Obvod_4OR is
begin
    C <= (A(3) or A(2)) or (A(1) or A(0));
end Spravanie;
---------------------------------------------
-- log clen AND
entity Obvod_AND is
    port (A:in Bit; B:in Bit; C:out Bit);
end Obvod_AND;

-- telo architektry AND
architecture Spravanie of Obvod_AND is
begin
    C <= A and B;
end Spravanie;
---------------------------------------------
-- trojvstupovy log clen AND
entity Obvod_3AND is
    port (A:in Bit_vector(2 downto 0); C:out Bit);
end Obvod_3AND;

-- telo architektry AND
architecture Spravanie of Obvod_3AND is
begin
    C <= (A(2) and A(1)) and A(0);
end Spravanie;
---------------------------------------------
-- log clen NOT
entity Obvod_NOT is
    port (A:in Bit; C:out Bit);
end Obvod_NOT;

-- telo architektry NOT
architecture Spravanie of Obvod_NOT is
begin
    C <= not(A);
end Spravanie;
---------------------------------------------
-- Prevodnik jednej cifry
entity Prevodnik is
    port (A:in Bit_vector(3 downto 0); C:out Bit_vector(4 downto 0));
end Prevodnik;

-- telo architektury Prevodnik
architecture Struktura of Prevodnik is
    component Obvod_AND is
       port (A:in Bit; B:in Bit; C:out Bit);
    end component;
    component Obvod_3AND is
       port (A:in Bit_vector(2 downto 0); C:out Bit);
    end component;
    component Obvod_3OR is
       port (A:in Bit_vector(2 downto 0); C:out Bit);
    end component;
    component Obvod_4OR is
       port (A:in Bit_vector(3 downto 0); C:out Bit);
    end component;
    component Obvod_NOT is
       port (A:in Bit; C:out Bit);
    end component;
    signal na, s1, s2, s3, s4, s5, s6, s7: Bit;
begin
    NOT1: Obvod_NOT
       port map(A => A(3), C => na);
    AND1: Obvod_AND
       port map(A => A(2), B => A(0), C => s1);
    AND2: Obvod_3AND
       port map(A(2) => A(1), A(1) => A(0), A(0) => na, C => s2);
    AND3: Obvod_AND
       port map(A => A(2), B => A(1), C => s3);
    AND4: Obvod_AND
       port map(A => A(2), B => na, C => s4);
    AND5: Obvod_AND
       port map(A => A(1), B => na, C => s5);
    AND6: Obvod_AND
       port map(A => A(0), B => na, C => s6);
    AND7: Obvod_3AND
       port map(A(2) => A(2), A(1) => A(1), A(0) => A(0), C => s7);
    OR1: Obvod_4OR
       port map(A(3) => s1, A(2) => s2, A(1) => s3, A(0) => s4, C => C(2));
    OR2: Obvod_3OR
       port map(A(2) => s3, A(1) => s4, A(0) => s5, C => C(1));
    OR3: Obvod_4OR
       port map(A(3) => s4, A(2) => s5, A(1) => s6, A(0) => s7, C => C(0));
    C(4) <= A(3);
    C(3) <= A(2);
end Struktura;

architecture Spravanie of Prevodnik is
begin
    C(4) <= A(3);
    C(3) <= A(2);
    C(2) <= ((A(2) and A(0)) or ((not(A(3)) and A(1)) and A(0))) or ((A(2) and  A(1)) or (not(A(3)) and A(2)));
    C(1) <= ((A(2) and A(1)) or (not(A(3)) and A(1))) or (not(A(3)) and A(2));
    C(0) <= ((not(A(3)) and A(0)) or (not(A(3)) and A(2))) or ((not(A(3)) and A(1)) or ((A(2) and A(1)) and A(0)));
end Spravanie;   
---------------------------------------------
-- Prevodnik troch cifier
entity Prevodnik3 is
    port (A1:in Bit_vector(3 downto 0); A2:in Bit_vector(3 downto 0); A3:in Bit_vector(3 downto 0); C1:out Bit_vector(4 downto 0); C2:out Bit_vector(4 downto 0); C3:out Bit_vector(4 downto 0));
end Prevodnik3;

-- telo architektury Prevodnik
architecture Struktura of Prevodnik3 is
    component Prevodnik is
       port (A:in Bit_vector(3 downto 0); C:out Bit_vector(4 downto 0)); 
    end component;
begin
    P1: Prevodnik
       port map(A => A1, C => C1);
    P2: Prevodnik
       port map(A => A2, C => C2);
    P3: Prevodnik
       port map(A => A3, C => C3);
end Struktura;

architecture Spravanie of Prevodnik3 is
begin
    C1(4) <= A1(3);
    C1(3) <= A1(2);
    C1(2) <= ((A1(2) and A1(0)) or ((not(A1(3)) and A1(1)) and A1(0))) or ((A1(2) and  A1(1)) or (not(A1(3)) and A1(2)));
    C1(1) <= ((A1(2) and A1(1)) or (not(A1(3)) and A1(1))) or (not(A1(3)) and A1(2));
    C1(0) <= ((not(A1(3)) and A1(0)) or (not(A1(3)) and A1(2))) or ((not(A1(3)) and A1(1)) or ((A1(2) and A1(1)) and A1(0)));
    C2(4) <= A2(3);
    C2(3) <= A2(2);
    C2(2) <= ((A2(2) and A2(0)) or ((not(A2(3)) and A2(1)) and A2(0))) or ((A2(2) and  A2(1)) or (not(A2(3)) and A2(2)));
    C2(1) <= ((A2(2) and A2(1)) or (not(A2(3)) and A2(1))) or (not(A2(3)) and A2(2));
    C2(0) <= ((not(A2(3)) and A2(0)) or (not(A2(3)) and A2(2))) or ((not(A2(3)) and A2(1)) or ((A2(2) and A2(1)) and A2(0)));
    C3(4) <= A3(3);
    C3(3) <= A3(2);
    C3(2) <= ((A3(2) and A3(0)) or ((not(A3(3)) and A3(1)) and A3(0))) or ((A3(2) and  A3(1)) or (not(A3(3)) and A3(2)));
    C3(1) <= ((A3(2) and A3(1)) or (not(A3(3)) and A3(1))) or (not(A3(3)) and A3(2));
    C3(0) <= ((not(A3(3)) and A3(0)) or (not(A3(3)) and A3(2))) or ((not(A3(3)) and A3(1)) or ((A3(2) and A3(1)) and A3(0)));
end Spravanie;
---------------------------------------------    
-- testovanie
entity Test is
end Test;

architecture stimulus of Test is
    component Prevodnik3 is
       port (A1:in Bit_vector(3 downto 0); A2:in Bit_vector(3 downto 0); A3:in Bit_vector(3 downto 0); C1:out Bit_vector(4 downto 0); C2:out Bit_vector(4 downto 0); C3:out Bit_vector(4 downto 0));
    end component;
    signal s1, s2, s3 : Bit_vector(3 downto 0) := "0000";
    signal o11, o12, o13, o21, o22, o23 : Bit_vector(4 downto 0) := "00000";
    for A: Prevodnik3 use entity work.Prevodnik3(Struktura);
    for B: Prevodnik3 use entity work.Prevodnik3(Spravanie);
begin
    A: Prevodnik3
       port map(A1 => s1, A2 => s2, A3 => s3, C1 => o11, C2 => o12, C3 => o13);
    B: Prevodnik3
       port map(A1 => s1, A2 => s2, A3 => s3, C1 => o21, C2 => o22, C3 => o23);
    
    STIMULUS1: s1 <= "0001" after 5 ns, "0100" after 10 ns, "1101" after 15 ns, "0101" after 20 ns;
    STIMULUS2: s2 <= "0010" after 5 ns, "1011" after 10 ns, "1110" after 15 ns, "0110" after 20 ns;
    STIMULUS3: s3 <= "0011" after 5 ns, "1100" after 10 ns, "1111" after 15 ns, "0111" after 20 ns;
end stimulus;